package repository

import "context"

// MemberOnlineStatusRepository 會員上限狀態，使用Bitmap
type MemberOnlineStatusRepository interface {
	SetMemberOnline(ctx context.Context, uid string) (bool, error)
	SetMemberOffline(ctx context.Context, uid string) (bool, error)
	IsMemberOnline(ctx context.Context, uid string) (bool, error)
	QueryMemberOnlineList(ctx context.Context, uids []string) ([]MemberOnlineStatusResp, error)
}

type MemberOnlineStatusResp struct {
	UID    string
	Status bool
}
